#version 400

layout (location = 0) in vec3 vertexPosition;

out vec3 outPosition;

uniform mat4 DepthBiasMVP;

out vec4 ShadowCoord;

uniform mat4 MVP;

uniform sampler2D terrain;

void main()
{

	vec2 texcoord = vertexPosition.xz;
    //float height = (texture(terrain, texcoord).r + texture(terrain, texcoord).g + texture(terrain, texcoord).b)/3.0f;
    float height = texture(terrain, texcoord).r;
    vec4 displaced = vec4(
        vertexPosition.x, 
        height,
        vertexPosition.z, 1.0);
    
	ShadowCoord = DepthBiasMVP * displaced;   

    //gl_Position = displaced;

    gl_Position = vec4(vertexPosition, 1.0f);


}
